
#include "display.h"


extern void _filemenu_notify_proc(Menu menu,Menu_item menu_item);
extern void _entrymenu_notify_proc(Menu menu,Menu_item menu_item);
extern void _searchmenu_notify_proc(Menu menu,Menu_item menu_item);
extern void _dialmenu_notify_proc(Menu menu,Menu_item menu_item);
extern int  _entrylist_notify_proc(Panel_item item,char *string,Xv_opaque client_data,Panel_list_op op,Event *event);
extern int  _classlist_notify_proc(Panel_item item,char *string,Xv_opaque client_data,Panel_list_op op,Event *event);
extern int  _cancel_notify_proc(Panel_item item,Event *event);
extern int  _search_notify_proc(Panel_item item,Event *event);
extern int  _name_checkbox_notify_proc(Panel_item item,unsigned value,Event *event);
extern int  _phone_checkbox_notify_proc(Panel_item item,unsigned value,Event *event);
extern int  _address_checkbox_notify_proc(Panel_item item,unsigned value,Event *event);
extern int  _new_file_notify_proc(File_chooser file_chooser,char *path);
extern int  _open_file_notify_proc(File_chooser file_chooser,char *path,char *file);
extern int  _classchoice_notify_proc(Panel_item item,char *string,Xv_opaque client_data,Panel_list_op op,Event *event);
extern int  _entry_apply_notify_proc(Panel_item item,Event *event);
extern int  _dial_apply_notify_proc(Panel_item item,Event *event);
extern void _classchoice_insert(Xv_opaque list,char *class);
extern void _entry_clean(entry_objects *Hot_entry);
 

parent_objects * create_parent(parent_objects *ip,Xv_opaque owner)
{
	if ((ip = (parent_objects *) calloc(1,sizeof(parent_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(NULL,FRAME,
			XV_WIDTH,400,
			XV_HEIGHT,440,
			FRAME_LABEL,"Hot Page",
			FRAME_SHOW_RESIZE_CORNER,FALSE,
			FRAME_SHOW_FOOTER,TRUE,
			FRAME_RIGHT_FOOTER,"Hotpage",
			FRAME_LEFT_FOOTER,"Please open Hotpage file.",
			NULL);
	
	ip->panel = xv_create(ip->frame,PANEL,NULL);
	
 	ip->new  = xv_create(ip->frame,FILE_CHOOSER_SAVE_DIALOG,
			FRAME_LABEL,"New",
			FILE_CHOOSER_NOTIFY_FUNC,_new_file_notify_proc,
			FILE_CHOOSER_AUTO_UPDATE,TRUE,
			NULL);
	
	ip->open = xv_create(ip->frame,FILE_CHOOSER_OPEN_DIALOG,
			FILE_CHOOSER_NOTIFY_FUNC,_open_file_notify_proc,
			FILE_CHOOSER_AUTO_UPDATE,TRUE,
			NULL);
	
	ip->filemenu = xv_create(NULL,MENU,
			MENU_STRINGS,"New","Open","Quit",NULL,
			MENU_NOTIFY_PROC,_filemenu_notify_proc,
			NULL);

	xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"File",
			PANEL_ITEM_MENU,ip->filemenu,
			NULL);
	 
	ip->entrymenu = xv_create(NULL,MENU,
			MENU_STRINGS,"Add","Edit","Delete",NULL,
			MENU_NOTIFY_PROC, _entrymenu_notify_proc,
			NULL);
	
	ip->entry = xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Entry",
			PANEL_ITEM_MENU,ip->entrymenu,
			PANEL_INACTIVE,TRUE,
			NULL);
			
	ip->searchmenu = xv_create(NULL,MENU,
			MENU_STRINGS,"Name","Phone Number","Address",NULL,
			MENU_NOTIFY_PROC, _searchmenu_notify_proc,
			NULL);
	
	ip->search = xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Search",
			PANEL_ITEM_MENU,ip->searchmenu,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	ip->dialmenu = xv_create(NULL,MENU,
			MENU_STRINGS,"Dial","Setting",NULL,
			MENU_NOTIFY_PROC,_dialmenu_notify_proc,
			NULL);
			
	ip->dial = xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Dial",
			PANEL_ITEM_MENU,ip->dialmenu,
			PANEL_INACTIVE,TRUE,
			NULL);
							
	ip->classlist = xv_create(ip->panel,PANEL_LIST,
			XV_X,5,
			XV_Y,40,
			PANEL_LIST_DISPLAY_ROWS,19,
			PANEL_LIST_WIDTH,100,
			PANEL_LIST_TITLE,"Class",
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_READ_ONLY,TRUE,
			PANEL_CHOOSE_ONE,TRUE,
			PANEL_NOTIFY_PROC, _classlist_notify_proc,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	ip->entrylist = xv_create(ip->panel,PANEL_LIST,
			XV_X,130,
			XV_Y,40,
			PANEL_LIST_DISPLAY_ROWS,19,
			PANEL_LIST_WIDTH,250,
			PANEL_LIST_TITLE,"Entry",
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_READ_ONLY,TRUE,
			PANEL_CHOOSE_ONE,TRUE,
			PANEL_LIST_DO_DBL_CLICK,TRUE,
			PANEL_NOTIFY_PROC, _entrylist_notify_proc,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	return (ip);
}


info_objects * create_info(info_objects *ip,Xv_opaque owner)
{
	if ((ip = (info_objects *) calloc(1,sizeof(info_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(owner,FRAME_CMD,
			FRAME_LABEL,"Hot Page",
			XV_WIDTH,450,
			XV_HEIGHT,230,
			NULL);
	
	ip->panel = (Panel)xv_get(ip->frame,FRAME_CMD_PANEL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,10,
			XV_Y,10,
			PANEL_LABEL_STRING,"Name",
			NULL);
	
	ip->name = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,50,
			XV_Y,10,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,280,
			XV_Y,10,
			PANEL_LABEL_STRING,"Class",
			NULL);
	
	ip->class = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,320,
			XV_Y,10,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,10,
			XV_Y,30,
			PANEL_LABEL_STRING,"Phone Number",
			NULL);
	
	ip->phone = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,110,
			XV_Y,30,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,10,
			XV_Y,50,
			PANEL_LABEL_STRING,"Fax Number",
			NULL);
	
	ip->fax = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,110,
			XV_Y,50,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,350,
			XV_Y,30,
			PANEL_LABEL_STRING,"Area",
			NULL);
	
	ip->area = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,350,
			XV_Y,50,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,10,
			XV_Y,70,
			PANEL_LABEL_STRING,"Address",
			NULL);
	
	ip->address = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,100,
			XV_Y,70,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,10,
			XV_Y,130,
			PANEL_LABEL_STRING,"Email",
			NULL);
	
	ip->email = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,50,
			XV_Y,130,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
			
	xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,10,
			XV_Y,150,
			PANEL_LABEL_STRING,"Notes",
			NULL);
	
	ip->notes[0] = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,50,
			XV_Y,150,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
			
	ip->notes[1] = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,50,
			XV_Y,170,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
			
	ip->notes[2] = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,50,
			XV_Y,190,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
			
	ip->notes[3] = xv_create(ip->panel,PANEL_MESSAGE,
			XV_X,50,
			XV_Y,210,
			PANEL_LABEL_BOLD,TRUE,
			NULL);
	
	return (ip);
}
		
			
entry_objects * create_entry(entry_objects *ip,Xv_opaque owner)
{
	if ((ip = (entry_objects *) calloc(1,sizeof(entry_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(owner,FRAME_CMD,
			FRAME_LABEL,"Hot Page Entry",
			XV_WIDTH,500,
			XV_HEIGHT,430,
			NULL);
	
	ip->panel = (Panel)xv_get(ip->frame,FRAME_CMD_PANEL);
	
	
	ip->firstname = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"First Name",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			NULL);
	
	ip->lastname = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Last Name",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			NULL);
				
	ip->class = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Class",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			NULL);
	
	ip->areachoice = xv_create(ip->panel,PANEL_CHOICE,
			PANEL_LABEL_STRING,"Area Choice",
			PANEL_CHOICE_STRINGS,"Local","Long Distance","International",NULL,
			NULL);
	
	ip->countrycode = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Country Code",
			PANEL_VALUE_DISPLAY_LENGTH,10,
			PANEL_VALUE_STORED_LENGTH,10,
			NULL);
	
	ip->areacode = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Area Code",
			PANEL_VALUE_DISPLAY_LENGTH,10,
			PANEL_VALUE_STORED_LENGTH,10,
			NULL);
	
	ip->phone = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Phone Number",
			PANEL_VALUE_DISPLAY_LENGTH,15,
			PANEL_VALUE_STORED_LENGTH,15,
			NULL);
	
	ip->fax = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Fax Number",
			PANEL_VALUE_DISPLAY_LENGTH,15,
			PANEL_VALUE_STORED_LENGTH,15,
			NULL);
	
	ip->address = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Address",
			PANEL_VALUE_DISPLAY_LENGTH,40,
			PANEL_VALUE_STORED_LENGTH,40,
			NULL);
	
	ip->city = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"City ",
			PANEL_VALUE_DISPLAY_LENGTH,40,
			PANEL_VALUE_STORED_LENGTH,40,
			NULL);
	
	ip->state = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"State ",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			NULL);
	
	ip->zip = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Zip",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			NULL);
	
	ip->country = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Country",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			NULL);
	
	ip->email = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Email",
			PANEL_VALUE_DISPLAY_LENGTH,50,
			PANEL_VALUE_STORED_LENGTH,50,
			NULL);
	
	ip->notes[0] = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"Notes",
			PANEL_VALUE_DISPLAY_LENGTH,50,
			PANEL_VALUE_STORED_LENGTH,50,
			NULL);
	
	ip->notes[1] = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"          ",
			PANEL_VALUE_DISPLAY_LENGTH,50,
			PANEL_VALUE_STORED_LENGTH,50,
			NULL);
	
	ip->notes[2] = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"          ",
			PANEL_VALUE_DISPLAY_LENGTH,50,
			PANEL_VALUE_STORED_LENGTH,50,
			NULL);
	
	ip->notes[3] = xv_create(ip->panel,PANEL_TEXT,
			PANEL_LABEL_STRING,"          ",
			PANEL_VALUE_DISPLAY_LENGTH,50,
			PANEL_VALUE_STORED_LENGTH,50,
			NULL);
	
	ip->apply = xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Apply",
			PANEL_NOTIFY_PROC,_entry_apply_notify_proc,
			NULL);
	
	ip->addmore = xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Add more",
			PANEL_NOTIFY_PROC,_entry_apply_notify_proc,
			NULL);
	
	xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Cancel",
			PANEL_NOTIFY_PROC,_cancel_notify_proc,
			NULL);
			
	ip->classchoice = xv_create(ip->panel,PANEL_LIST,
			XV_X,360,
			XV_Y,25,
			PANEL_LABEL_STRING,"Class",
			PANEL_LIST_STRING,0,"new class",
			PANEL_LIST_DISPLAY_ROWS,3,
			PANEL_LIST_WIDTH,100,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_READ_ONLY,TRUE,
			PANEL_CHOOSE_ONE,TRUE,
			PANEL_NOTIFY_PROC, _classchoice_notify_proc,
			NULL);
	
	return (ip);

}


name_search_objects * create_name_search(name_search_objects *ip,Xv_opaque owner)
{
	if ((ip = (name_search_objects *) calloc(1,sizeof(name_search_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(owner,FRAME_CMD,
			FRAME_LABEL,"Name Search",
			XV_WIDTH,500,
			XV_HEIGHT,200,
			NULL);
	
	ip->panel = (Panel)xv_get(ip->frame,FRAME_CMD_PANEL);
	
	ip->checkbox = xv_create(ip->panel,PANEL_CHOICE,
			PANEL_FEEDBACK,PANEL_MARKED,
			PANEL_CHOOSE_ONE,FALSE,
			PANEL_CHOICE_STRINGS,"First Name","Last Name",NULL,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_NOTIFY_PROC,_name_checkbox_notify_proc,
			NULL);
	
	ip->firstname = xv_create(ip->panel,PANEL_TEXT,
			XV_X,113,
			XV_Y,8,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			PANEL_INACTIVE,TRUE,
			NULL);
	

	ip->lastname = xv_create(ip->panel,PANEL_TEXT,
			XV_X,113,
			XV_Y,37,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			PANEL_INACTIVE,TRUE,
			NULL);

	ip->entrylist = xv_create(ip->panel,PANEL_LIST,
			XV_X,280,
			XV_Y,15,
			PANEL_LIST_TITLE,"Entry",
			PANEL_LIST_DISPLAY_ROWS,7,
			PANEL_LIST_WIDTH,200,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_READ_ONLY,TRUE,
			PANEL_CHOOSE_ONE,TRUE,
			PANEL_NOTIFY_PROC, _entrylist_notify_proc,
			NULL);
	
	ip->search = xv_create(ip->panel,PANEL_BUTTON,
			XV_X,10,
			XV_Y,170,
			PANEL_LABEL_STRING,"Search",
			PANEL_CLIENT_DATA,SEARCH_NAME,
			PANEL_INACTIVE,TRUE,
			PANEL_NOTIFY_PROC,_search_notify_proc,
			NULL);
	
	xv_create(ip->panel,PANEL_BUTTON,
			XV_X,80,
			XV_Y,170,
			PANEL_LABEL_STRING,"Cancel",
			PANEL_NOTIFY_PROC,_cancel_notify_proc,
			NULL);
	
	
	return (ip);

}


phone_search_objects * create_phone_search(phone_search_objects *ip,Xv_opaque owner)
{
	if ((ip = (phone_search_objects *) calloc(1,sizeof(phone_search_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(owner,FRAME_CMD,
			FRAME_LABEL,"Phone Number Search",
			XV_WIDTH,500,
			XV_HEIGHT,200,
			NULL);
	
	ip->panel = (Panel)xv_get(ip->frame,FRAME_CMD_PANEL);
	
	ip->checkbox = xv_create(ip->panel,PANEL_CHOICE,
			PANEL_FEEDBACK,PANEL_MARKED,
			PANEL_CHOOSE_ONE,FALSE,
			PANEL_CHOICE_STRINGS,"Country Code","Area Code","Phone Number",NULL,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_NOTIFY_PROC,_phone_checkbox_notify_proc,
			NULL);
	
	ip->countrycode = xv_create(ip->panel,PANEL_TEXT,
			XV_X,138,
			XV_Y,6,
			PANEL_VALUE_DISPLAY_LENGTH,10,
			PANEL_VALUE_STORED_LENGTH,10,
			PANEL_INACTIVE,TRUE,
			NULL);
	

	ip->areacode = xv_create(ip->panel,PANEL_TEXT,
			XV_X,138,
			XV_Y,37,
			PANEL_VALUE_DISPLAY_LENGTH,10,
			PANEL_VALUE_STORED_LENGTH,10,
			PANEL_INACTIVE,TRUE,
			NULL);

	ip->phone = xv_create(ip->panel,PANEL_TEXT,
			XV_X,138,
			XV_Y,66,
			PANEL_VALUE_DISPLAY_LENGTH,15,
			PANEL_VALUE_STORED_LENGTH,15,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	ip->entrylist = xv_create(ip->panel,PANEL_LIST,
			XV_X,280,
			XV_Y,15,
			PANEL_LIST_TITLE,"Entry",
			PANEL_LIST_DISPLAY_ROWS,7,
			PANEL_LIST_WIDTH,200,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_READ_ONLY,TRUE,
			PANEL_CHOOSE_ONE,TRUE,
			PANEL_NOTIFY_PROC, _entrylist_notify_proc,
			NULL);
	
	ip->search = xv_create(ip->panel,PANEL_BUTTON,
			XV_X,10,
			XV_Y,170,
			PANEL_LABEL_STRING,"Search",
			PANEL_CLIENT_DATA,SEARCH_PHONE,
			PANEL_INACTIVE,TRUE,
			PANEL_NOTIFY_PROC,_search_notify_proc,
			NULL);
	
	xv_create(ip->panel,PANEL_BUTTON,
			XV_X,80,
			XV_Y,170,
			PANEL_LABEL_STRING,"Cancel",
			PANEL_NOTIFY_PROC,_cancel_notify_proc,
			NULL);
	
	
	return (ip);

}


address_search_objects * create_address_search(address_search_objects *ip,Xv_opaque owner)
{
	if ((ip = (address_search_objects *) calloc(1,sizeof(address_search_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(owner,FRAME_CMD,
			FRAME_LABEL,"Address Search",
			XV_WIDTH,500,
			XV_HEIGHT,200,
			NULL);
	
	ip->panel = (Panel)xv_get(ip->frame,FRAME_CMD_PANEL);
	
	ip->checkbox = xv_create(ip->panel,PANEL_CHOICE,
			PANEL_FEEDBACK,PANEL_MARKED,
			PANEL_CHOOSE_ONE,FALSE,
			PANEL_CHOICE_STRINGS,"Address","City","State","Zip","Country",NULL,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_NOTIFY_PROC,_address_checkbox_notify_proc,
			NULL);
	
	ip->address = xv_create(ip->panel,PANEL_TEXT,
			XV_X,96,
			XV_Y,8,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,40,
			PANEL_INACTIVE,TRUE,
			NULL);
	

	ip->city = xv_create(ip->panel,PANEL_TEXT,
			XV_X,96,
			XV_Y,37,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,40,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	ip->state = xv_create(ip->panel,PANEL_TEXT,
			XV_X,96,
			XV_Y,66,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	ip->zip = xv_create(ip->panel,PANEL_TEXT,
			XV_X,96,
			XV_Y,95,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			PANEL_INACTIVE,TRUE,
			NULL);
	
	ip->country = xv_create(ip->panel,PANEL_TEXT,
			XV_X,96,
			XV_Y,124,
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,20,
			PANEL_INACTIVE,TRUE,
			NULL);

	ip->entrylist = xv_create(ip->panel,PANEL_LIST,
			XV_X,280,
			XV_Y,15,
			PANEL_LIST_TITLE,"Entry",
			PANEL_LIST_DISPLAY_ROWS,7,
			PANEL_LIST_WIDTH,200,
			PANEL_LAYOUT,PANEL_VERTICAL,
			PANEL_READ_ONLY,TRUE,
			PANEL_CHOOSE_ONE,TRUE,
			PANEL_NOTIFY_PROC, _entrylist_notify_proc,
			NULL);
	
	ip->search = xv_create(ip->panel,PANEL_BUTTON,
			XV_X,10,
			XV_Y,170,
			PANEL_LABEL_STRING,"Search",
			PANEL_CLIENT_DATA,SEARCH_ADDRESS,
			PANEL_INACTIVE,TRUE,
			PANEL_NOTIFY_PROC,_search_notify_proc,
			NULL);
	
	xv_create(ip->panel,PANEL_BUTTON,
			XV_X,80,
			XV_Y,170,
			PANEL_LABEL_STRING,"Cancel",
			PANEL_NOTIFY_PROC,_cancel_notify_proc,
			NULL);
	
	
	return (ip);

}

dial_objects * create_dial(dial_objects *ip,Xv_opaque owner)
{
	if ((ip = (dial_objects *) calloc(1,sizeof(dial_objects))) == NULL)
		return (NULL);
	
	ip->frame = xv_create(owner,FRAME_CMD,
			FRAME_LABEL,"Setting",
			XV_WIDTH,400,
			XV_HEIGHT,100,
			NULL);
	
	ip->panel = (Panel)xv_get(ip->frame,FRAME_CMD_PANEL);
	
	ip->prefix = xv_create(ip->panel,PANEL_TEXT,
			XV_X,10,
			XV_Y,10,
			PANEL_LABEL_STRING,"Internatinal call prefix code",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			NULL);
	
	ip->devfile = xv_create(ip->panel,PANEL_TEXT,
			XV_X,10,
			XV_Y,30,
			PANEL_LABEL_STRING,"Modem device filename",
			PANEL_VALUE_DISPLAY_LENGTH,20,
			PANEL_VALUE_STORED_LENGTH,256,
			NULL);
	
	ip->torp = xv_create(ip->panel,PANEL_CHOICE,
			XV_X,10,
			XV_Y,60,
			PANEL_LABEL_STRING,"Dial",
			PANEL_CHOICE_STRINGS,"Tone","Pulse",NULL,
			NULL);
	
	ip->apply = xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Apply",
			PANEL_NOTIFY_PROC, _dial_apply_notify_proc,
			NULL);
	
	xv_create(ip->panel,PANEL_BUTTON,
			PANEL_LABEL_STRING,"Cancel",
			PANEL_NOTIFY_PROC, _cancel_notify_proc,
			NULL);

	return (ip);
}

void _filemenu_notify_proc(Menu menu,Menu_item menu_item)
{
	if(!strcmp("New",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_parent->new,XV_SHOW,TRUE,NULL);
	}
	if(!strcmp("Open",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_parent->open,XV_SHOW,TRUE,NULL);
	}
	if(!strcmp("Quit",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_destroy_safe(Hot_parent->frame);
	}
}

void _entrymenu_notify_proc(Menu menu,Menu_item menu_item)
{
	if(!strcmp("Add",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_add->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	}
	
	if(!strcmp("Edit",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_edit->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	}
	
	if(!strcmp("Delete",(char *)xv_get(menu_item,MENU_STRING))) {
		if(notice("Please confirm.\n",NOTICE_TYPE_YES_NO,"Delete","Cancel") == NOTICE_YES)
			delete_info(current_info.number);
	}
}
	

void _searchmenu_notify_proc(Menu menu,Menu_item menu_item)
{
	if(!strcmp("Name",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_name_search->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	}
	if(!strcmp("Phone Number",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_phone_search->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	}
	if(!strcmp("Address",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_address_search->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	}
}

void _dialmenu_notify_proc(Menu menu,Menu_item menu_item)
{
	if(!strcmp("Dial",(char *)xv_get(menu_item,MENU_STRING))) {
		dial_start(generated_num());
	}
	if(!strcmp("Setting",(char *)xv_get(menu_item,MENU_STRING))) {
		xv_set(Hot_dial->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	}
}

int  _classlist_notify_proc(Panel_item item,char *string,Xv_opaque client_data,
					Panel_list_op op,Event *event)
{
	switch(op) {
	case PANEL_LIST_OP_SELECT:
		entry_listup(string);
		break;
	case PANEL_LIST_OP_DESELECT:
	case PANEL_LIST_OP_VALIDATE:
	case PANEL_LIST_OP_DELETE:
	}
	
	return XV_OK;
}

int  _entrylist_notify_proc(Panel_item item,char *string,Xv_opaque client_data,
					Panel_list_op op,Event *event)
{
	switch(op) {
	case PANEL_LIST_OP_DESELECT:
	case PANEL_LIST_OP_VALIDATE:
	case PANEL_LIST_OP_DELETE:
		break;
	case PANEL_LIST_OP_DBL_CLICK:
		xv_set(Hot_info->frame,
			XV_SHOW,TRUE,
			FRAME_CMD_PUSHPIN_IN,TRUE,
			NULL);
	case PANEL_LIST_OP_SELECT:
		set_current(client_data);
	}
	
	return XV_OK;
}

int  _cancel_notify_proc(Panel_item item,Event *event)
{
	Frame frame;
	Panel panel;
	
	panel = (Panel)xv_get(item,XV_OWNER);
	frame = (Frame)xv_get(panel,XV_OWNER);
	
	xv_set(frame,FRAME_CMD_PUSHPIN_IN,FALSE,XV_SHOW,FALSE,NULL);
	
	return XV_OK;
}

int  _search_notify_proc(Panel_item item,Event *event)
{
	switch((Search_type)xv_get(item,PANEL_CLIENT_DATA)) {
	case SEARCH_NAME:
		search_name((unsigned)xv_get(Hot_name_search->checkbox,PANEL_VALUE),
			(char *)xv_get(Hot_name_search->firstname,PANEL_VALUE),
			(char *)xv_get(Hot_name_search->lastname,PANEL_VALUE));
		break;
	case SEARCH_PHONE:
		search_phone((unsigned)xv_get(Hot_phone_search->checkbox,PANEL_VALUE),
			(char *)xv_get(Hot_phone_search->countrycode,PANEL_VALUE),
			(char *)xv_get(Hot_phone_search->areacode,PANEL_VALUE),
			(char *)xv_get(Hot_phone_search->phone,PANEL_VALUE));
		break;
	case SEARCH_ADDRESS:
		search_address((unsigned)xv_get(Hot_address_search->checkbox,PANEL_VALUE),
			(char *)xv_get(Hot_address_search->address,PANEL_VALUE),
			(char *)xv_get(Hot_address_search->city,PANEL_VALUE),
			(char *)xv_get(Hot_address_search->state,PANEL_VALUE),
			(char *)xv_get(Hot_address_search->zip,PANEL_VALUE),
			(char *)xv_get(Hot_address_search->country,PANEL_VALUE));
		break;
	}
	
	return XV_OK;
}

	  
int  _name_checkbox_notify_proc(Panel_item item,unsigned value,Event *event)
{
	int searchflag;
	
	searchflag = 0;
	
	if(event_id(event) == MS_LEFT) {
		if(value & 1) { 
			xv_set(Hot_name_search->firstname,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_name_search->firstname,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_name_search->lastname,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_name_search->lastname,PANEL_INACTIVE,TRUE,NULL);
		
		if(searchflag)
			xv_set(Hot_name_search->search,PANEL_INACTIVE,FALSE,NULL);
		else
			xv_set(Hot_name_search->search,PANEL_INACTIVE,TRUE,NULL);
			
		return XV_OK;
	}
	
	return XV_ERROR;
}


int  _phone_checkbox_notify_proc(Panel_item item,unsigned value,Event *event)
{
	int searchflag;
	
	searchflag = 0;
	
	if(event_id(event) == MS_LEFT) {
		if(value & 1) {
			xv_set(Hot_phone_search->countrycode,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_phone_search->countrycode,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_phone_search->areacode,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_phone_search->areacode,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_phone_search->phone,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_phone_search->phone,PANEL_INACTIVE,TRUE,NULL);
		
		if(searchflag)
			xv_set(Hot_phone_search->search,PANEL_INACTIVE,FALSE,NULL);
		else
			xv_set(Hot_phone_search->search,PANEL_INACTIVE,TRUE,NULL);
			
		return XV_OK;
	}
	
	return XV_ERROR;
}


int  _address_checkbox_notify_proc(Panel_item item,unsigned value,Event *event)
{
	int searchflag;
	
	searchflag = 0;
	
	if(event_id(event) == MS_LEFT) {
		if(value & 1) { 
			xv_set(Hot_address_search->address,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_address_search->address,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_address_search->city,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_address_search->city,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_address_search->state,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_address_search->state,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_address_search->zip,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_address_search->zip,PANEL_INACTIVE,TRUE,NULL);
		
		value >>= 1;
		if(value & 1) {
			xv_set(Hot_address_search->country,PANEL_INACTIVE,FALSE,NULL);
			searchflag = 1;
		}
		else
			xv_set(Hot_address_search->country,PANEL_INACTIVE,TRUE,NULL);
		
		if(searchflag)
			xv_set(Hot_address_search->search,PANEL_INACTIVE,FALSE,NULL);
		else
			xv_set(Hot_address_search->search,PANEL_INACTIVE,TRUE,NULL);
		
		return XV_OK;
	}
	
	return XV_ERROR;
}


int  _new_file_notify_proc(File_chooser file_chooser,char *path)
{
	char file[256];
	
	if(file_open(path,FILE_OPEN_NEW) == TRUE) {
		xv_set(Hot_parent->entry,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->search,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->dial,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->classlist,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->entrylist,PANEL_INACTIVE,FALSE,NULL);
		strcpy(file, (char *)xv_get(xv_get(file_chooser,FILE_CHOOSER_CHILD,FILE_CHOOSER_DOCUMENT_NAME_CHILD),PANEL_VALUE));
		show_filename(file);
		foot("Hotpage");
	}
		
	return XV_OK;
}


int  _open_file_notify_proc(File_chooser file_chooser,char *path,char *file)
{
	if(file_open(path,FILE_OPEN_EXISTING) == TRUE) {
		xv_set(Hot_parent->entry,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->search,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->dial,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->classlist,PANEL_INACTIVE,FALSE,NULL);
		xv_set(Hot_parent->entrylist,PANEL_INACTIVE,FALSE,NULL);
		show_filename(file);
		foot("Hotpage");
	}
	
	return XV_OK;
}

int  _classchoice_notify_proc(Panel_item item,char *string,Xv_opaque client_data,
					Panel_list_op op,Event *event)
{
	char class[22];
	
	strcpy(class,string);	
	if(!strcmp(string,"new class"))
		strcpy(class,"");
	
	switch((Update_type)xv_get((Panel)xv_get(item,PANEL_PARENT_PANEL),XV_KEY_DATA,UPDATE_TYPE)) {
	case UPDATE_NEW:
		xv_set(Hot_add->class,PANEL_VALUE,class,NULL);
		break;
	case UPDATE_EDIT:
		xv_set(Hot_edit->class,PANEL_VALUE,class,NULL);
		break;
	}
	
	return XV_OK;
}


int  _entry_apply_notify_proc(Panel_item item,Event *event)
{
	entry_objects  *Hot_entry;
	Person_information info;
		
	switch((Update_type)xv_get((Panel)xv_get(item,PANEL_PARENT_PANEL),XV_KEY_DATA,UPDATE_TYPE)) {
	case UPDATE_NEW:
		Hot_entry = Hot_add;	
		break;
	case UPDATE_EDIT:
		Hot_entry = Hot_edit;
		info.number = current_info.number;
		break;
	}
	
	strcpy(info.first,(char *)xv_get(Hot_entry->firstname,PANEL_VALUE));
	strcpy(info.last,(char *)xv_get(Hot_entry->lastname,PANEL_VALUE));
	strcpy(info.class,(char *)xv_get(Hot_entry->class,PANEL_VALUE));
	strcpy(info.countrycode,(char *)xv_get(Hot_entry->countrycode,PANEL_VALUE));
	strcpy(info.areacode,(char *)xv_get(Hot_entry->areacode,PANEL_VALUE));
	strcpy(info.phone,(char *)xv_get(Hot_entry->phone,PANEL_VALUE));
	strcpy(info.fax,(char *)xv_get(Hot_entry->fax,PANEL_VALUE));
	info.area = (int)xv_get(Hot_entry->areachoice,PANEL_VALUE);
	strcpy(info.address,(char *)xv_get(Hot_entry->address,PANEL_VALUE));
	strcpy(info.city,(char *)xv_get(Hot_entry->city,PANEL_VALUE));
	strcpy(info.state,(char *)xv_get(Hot_entry->state,PANEL_VALUE));
	strcpy(info.zip,(char *)xv_get(Hot_entry->zip,PANEL_VALUE));
	strcpy(info.country,(char *)xv_get(Hot_entry->country,PANEL_VALUE));
	strcpy(info.email,(char *)xv_get(Hot_entry->email,PANEL_VALUE));
	strcpy(info.notes[0],(char *)xv_get(Hot_entry->notes[0],PANEL_VALUE));
	strcpy(info.notes[1],(char *)xv_get(Hot_entry->notes[1],PANEL_VALUE));
	strcpy(info.notes[2],(char *)xv_get(Hot_entry->notes[2],PANEL_VALUE));
	strcpy(info.notes[3],(char *)xv_get(Hot_entry->notes[3],PANEL_VALUE));
	
	if( !strcmp(info.first,"") || !strcmp(info.last,"") || !strcmp(info.class,"")) {
		notice("Please entry at least\nfirst name, last name, and class.",NOTICE_TYPE_OK,"Dismiss","");
		return XV_OK;
	}
		
	if(entry_update(&info,(Update_type)xv_get((Panel)xv_get(item,PANEL_PARENT_PANEL),XV_KEY_DATA,UPDATE_TYPE)) == TRUE) {
		_entry_clean(Hot_entry);
		if(strcmp((char *)xv_get(item,PANEL_LABEL_STRING),"Add more"))
			xv_set(Hot_entry->frame,FRAME_CMD_PUSHPIN_IN,FALSE,XV_SHOW,FALSE,NULL);
	}
	
	return XV_OK;
}

int _dial_apply_notify_proc(Panel_item item,Event *event)
{
	strcpy(modem.prefixcode,(char *)xv_get(Hot_dial->prefix,PANEL_VALUE));
	strcpy(modem.modemdev,(char *)xv_get(Hot_dial->devfile,PANEL_VALUE));
	modem.toneorpuls = (int)xv_get(Hot_dial->torp,PANEL_VALUE);
	
	update_modem_setting_file();

	xv_set(Hot_dial->frame,FRAME_CMD_PUSHPIN_IN,FALSE,XV_SHOW,FALSE,NULL);

	
	return XV_OK;
}

	
void _entry_clean(entry_objects *Hot_entry)
{
	xv_set(Hot_entry->firstname,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->lastname,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->class,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->countrycode,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->areacode,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->phone,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->fax,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->areachoice,PANEL_VALUE,0,NULL); 
	xv_set(Hot_entry->address,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->city,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->state,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->zip,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->country,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->email,PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->notes[0],PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->notes[1],PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->notes[2],PANEL_VALUE,"",NULL);
	xv_set(Hot_entry->notes[3],PANEL_VALUE,"",NULL);
}	

void classlist_insert(Xv_opaque list,char *class)
{
	int rows;
	
	rows = (int)xv_get(list,PANEL_LIST_NROWS);
	
	_classchoice_insert(Hot_add->classchoice,class);
	_classchoice_insert(Hot_edit->classchoice,class);
	if(rows != 0)
		if(!strcmp(class,(char *)xv_get(list,PANEL_LIST_STRING,rows-1)))
			return;
	
	xv_set(list,
		PANEL_LIST_INSERT, rows,
		PANEL_LIST_STRING, rows, class,
		NULL);
}


void entrylist_insert(Xv_opaque list,char *first,char *last,int number)
{
	int rows;
	char fullname[42];
	
	rows = (int)xv_get(list,PANEL_LIST_NROWS);
	
	strcpy(fullname,last);
	strcat(fullname,", ");
	strcat(fullname,first);

	xv_set(list,
		PANEL_LIST_INSERT, rows,
		PANEL_LIST_STRING, rows, fullname,
		PANEL_LIST_CLIENT_DATA, rows, number,
		NULL);
}

void _classchoice_insert(Xv_opaque list,char *class)
{
	int i,rows;
	
	rows = (int)xv_get(list,PANEL_LIST_NROWS);
	
	if(rows != 0)
		if(!strcmp(class,(char *)xv_get(list,PANEL_LIST_STRING,rows-1))) 
			return;
	
	xv_set(list,
		PANEL_LIST_INSERT, rows,
		PANEL_LIST_STRING, rows, class,
		NULL);
}	

void list_clear(Xv_opaque list)
{
	int i,rows;
	
	xv_set(list,XV_SHOW,FALSE,NULL);

	rows = (int)xv_get(list,PANEL_LIST_NROWS);
	
	for(i=0;i<rows;i++) 
		xv_set(list,PANEL_LIST_DELETE,0,NULL);
		
	xv_set(list,XV_SHOW,TRUE,NULL);
}


int notice(char *message,Notice_type type,char *button_yes,char *button_no)
{
	int status;
	
	xv_set(Hot_parent->frame,FRAME_BUSY,TRUE,NULL);
	
	switch (type) {
	case NOTICE_TYPE_OK:
		status = notice_prompt(Hot_parent->panel,NULL,
				NOTICE_MESSAGE_STRING,message,
				NOTICE_BUTTON_YES,button_yes,
				NULL);
		break;
	case NOTICE_TYPE_YES_NO:
		status = notice_prompt(Hot_parent->panel,NULL,
				NOTICE_MESSAGE_STRING,message,
				NOTICE_BUTTON_YES,button_yes,
				NOTICE_BUTTON_NO,button_no,
				NULL);
		break;
	}
	
	xv_set(Hot_parent->frame,FRAME_BUSY,FALSE,NULL);

	return status;
}

void display_person_information(void)
{
	char buf[256];
		
	sprintf(buf,"%s %s",current_info.first,current_info.last);
	xv_set(Hot_info->name,PANEL_LABEL_STRING,buf,NULL);
	xv_set(Hot_info->class,PANEL_LABEL_STRING,current_info.class,NULL);
	switch(current_info.area) {
	case 0:
		xv_set(Hot_info->phone,PANEL_LABEL_STRING,current_info.phone,NULL);
		xv_set(Hot_info->fax,PANEL_LABEL_STRING,current_info.fax,NULL);
		xv_set(Hot_info->area,PANEL_LABEL_STRING,"Local",NULL);
		break;
	case 1:
		sprintf(buf,"(%s)%s",current_info.areacode,current_info.phone);
		xv_set(Hot_info->phone,PANEL_LABEL_STRING,buf,NULL);
		sprintf(buf,"(%s)%s",current_info.areacode,current_info.fax);
		xv_set(Hot_info->fax,PANEL_LABEL_STRING,buf,NULL);
		xv_set(Hot_info->area,PANEL_LABEL_STRING,"Long Distance",NULL);
		break;
	case 2:
		sprintf(buf,"+%s - (%s)%s",current_info.countrycode,current_info.areacode,current_info.phone);
		xv_set(Hot_info->phone,PANEL_LABEL_STRING,buf,NULL);
		sprintf(buf,"+%s - (%s)%s",current_info.countrycode,current_info.areacode,current_info.fax);
		xv_set(Hot_info->fax,PANEL_LABEL_STRING,buf,NULL);
		xv_set(Hot_info->area,PANEL_LABEL_STRING,"International",NULL);
		break;
	}
	sprintf(buf,"%s\n%s\n%s %s\n%s",current_info.address,
		current_info.city,current_info.state,
		current_info.zip,current_info.country);
	xv_set(Hot_info->address,PANEL_LABEL_STRING,buf,NULL);
	xv_set(Hot_info->email,PANEL_LABEL_STRING,current_info.email,NULL);
	xv_set(Hot_info->notes[0],PANEL_LABEL_STRING,current_info.notes[0],NULL);
	xv_set(Hot_info->notes[1],PANEL_LABEL_STRING,current_info.notes[1],NULL);
	xv_set(Hot_info->notes[2],PANEL_LABEL_STRING,current_info.notes[2],NULL);
	xv_set(Hot_info->notes[3],PANEL_LABEL_STRING,current_info.notes[3],NULL);

	/* Edit */
	
	xv_set(Hot_edit->firstname,PANEL_VALUE,current_info.first,NULL);
	xv_set(Hot_edit->lastname,PANEL_VALUE,current_info.last,NULL);
	xv_set(Hot_edit->class,PANEL_VALUE,current_info.class,NULL);
	xv_set(Hot_edit->areachoice,PANEL_VALUE,current_info.area,NULL);
	xv_set(Hot_edit->countrycode,PANEL_VALUE,current_info.countrycode,NULL);
	xv_set(Hot_edit->areacode,PANEL_VALUE,current_info.areacode,NULL);
	xv_set(Hot_edit->phone,PANEL_VALUE,current_info.phone,NULL);
	xv_set(Hot_edit->fax,PANEL_VALUE,current_info.fax,NULL);
	xv_set(Hot_edit->address,PANEL_VALUE,current_info.address,NULL);
	xv_set(Hot_edit->city,PANEL_VALUE,current_info.city,NULL);
	xv_set(Hot_edit->state,PANEL_VALUE,current_info.state,NULL);
	xv_set(Hot_edit->zip,PANEL_VALUE,current_info.zip,NULL);
	xv_set(Hot_edit->country,PANEL_VALUE,current_info.country,NULL);
	xv_set(Hot_edit->email,PANEL_VALUE,current_info.email,NULL);
	xv_set(Hot_edit->notes[0],PANEL_VALUE,current_info.notes[0],NULL);
	xv_set(Hot_edit->notes[1],PANEL_VALUE,current_info.notes[1],NULL);
	xv_set(Hot_edit->notes[2],PANEL_VALUE,current_info.notes[2],NULL);
	xv_set(Hot_edit->notes[3],PANEL_VALUE,current_info.notes[3],NULL);
}

void foot(char *message)
{
	xv_set(Hot_parent->frame,FRAME_RIGHT_FOOTER,message,NULL);
}

void show_filename(char *filename)
{
	xv_set(Hot_parent->frame,FRAME_LEFT_FOOTER,filename,NULL);
}

void display_modem_setting(void)
{
	xv_set(Hot_dial->prefix,PANEL_VALUE,modem.prefixcode,NULL);
	xv_set(Hot_dial->devfile,PANEL_VALUE,modem.modemdev,NULL);
	xv_set(Hot_dial->torp,PANEL_VALUE,modem.toneorpuls,NULL);
}

	